<?php
// $Id: mms_us_verizon.inc,v 1.1 2007/05/27 23:45:41 stuartgreenfield Exp $

/**
 * Implementation of hook_mailsave_clean().
 */
function mms_us_verizon_mailsave_clean(&$node, $result, $i, $header, $mailbox) {

  // Build regex to see if this was from vodafone
  $pattern = '@vzwpix.com$@';
  if (preg_match($pattern, $header->fromaddress)) {

    // Build a regex to extract message body
    // This regex identifies the actual message text in the email
    $end_pattern = preg_quote('This message was sent using PIX-FLIX Messaging service from Verizon Wireless!');
    $pattern = '@^(.*)' . $end_pattern . '@Us';

    // Check for regex success in case the provider changes their format
    // Worst case is that match fails and nothing is changed
    if (preg_match($pattern, $node->body, $matches)) {

      // Get the new body as a string
      $body = $matches[1];

      // Strip surplus white space
      $body = preg_replace('@\s\s+@', ' ', $body);

      // Store the amended body
      $node->body = $body;
      $node->teaser = node_teaser($node->body);

      // Replace generic title with portion of body
      $node->title = truncate_utf8($body, 60, TRUE, TRUE);

      // Discard text portion of message (is this filename always the same?)
      mailsave_discard_attachment($node, 'smiltextpartfilename0.txt');
    }
  }

  return;
}


/**
 * Report back module information when requested
 */
function mms_us_verizon_mailsave_clean_info() {
  $items['mms_us_verizon'] = array(
    'provider'    => t('Verizon'),
    'country'     => 'US',
    'author'      => 'Stuart Greenfield',
    'description' => t('Clean up MMS messages sent via the Verizon US network.'),
  );

  return $items;
}
